'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactTestRenderer = require('react-test-renderer');

var _CommentCount = require('../CommentCount');

var _CommentEmbed = require('../CommentEmbed');

var _DiscussionEmbed = require('../DiscussionEmbed');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var testArticle = {
    id: 'article-1',
    url: 'http://example.com/article-1/',
    title: 'Article 1',
    featuredComment: '3236451753'
};

var shortname = 'thegermaphobe';
var disqusConfig = {
    url: testArticle.url,
    identifier: testArticle.id,
    title: testArticle.title
};

describe('CommentCount component', function () {
    test('it matches the snapshot', function () {
        var component = (0, _reactTestRenderer.create)(_react2.default.createElement(
            _CommentCount.CommentCount,
            {
                shortname: shortname,
                config: disqusConfig },
            'Comments'
        ));
        expect(component.toJSON()).toMatchSnapshot();
    });
});

describe('CommentEmbed component', function () {
    test('it matches the snapshot', function () {
        var component = (0, _reactTestRenderer.create)(_react2.default.createElement(_CommentEmbed.CommentEmbed, {
            commentId: testArticle.featuredComment,
            showMedia: true,
            height: 160
        }));
        expect(component.toJSON()).toMatchSnapshot();
    });
});

describe('DiscussionEmbed component', function () {
    test('it matches the snapshot', function () {
        var component = (0, _reactTestRenderer.create)(_react2.default.createElement(_DiscussionEmbed.DiscussionEmbed, {
            shortname: shortname,
            config: disqusConfig
        }));
        expect(component.toJSON()).toMatchSnapshot();
    });
});